#include <stdio.h>
#include "/home/pwi/lib/libsctimecal-3.1.2/TIMECAL/include/TimeCal_type.h"

int main(int argc, char *argv[]){

  double	out1;
  unsigned int	out2;
  int           ret1, ret2;

  char		ut[21];
  unsigned int	ti;

  if(argc != 5){
    printf("./test <TI> <estimated utc> <range -> <range +>\n");
    printf("e.g. ./test 00000000 20180710235959 1 0\n");
    return(0);
  }

  //setTimeCalFile("/data/MMO/TIMCAL/time_cal_sa45_TEST");
  //setTimeCalFile("/home/pwi/MMO_MK_CDF/pwi-L1/OFA/spec/bin/time_cal_sa45_sm");
  //setTimeCalFile("time_cal_sa45_sm");
  setTimeCalFile("/data/MMO/TIMCAL/time_cal_sa45");
  setLeapSecFile("/data/MMO/TIMCAL/leapsec.dat");

  ti = strtol(argv[1], NULL, 16);

  printf("---------------\n");
  printf("TI: 0x%08X\n", ti);
  printf("estimated UTC: %s\n", argv[2]);
  printf("range (-): %d (day), (+): %d (day)\n", atoi(argv[3]), atoi(argv[4]));
  printf("---------------\n");

  ret1 = ti2es(argv[2], ti, &out1, &out2, atoi(argv[3]), atoi(argv[4]));  
  if(ret1 < 0){
    printf("ti2es error: %d(ret) %08X(ti)\n",ret1, ti);
    return -1;
  }else{
    printf("ti2es(): out1=%lf, out2=%d\n", out1, out2);
  }

  ret2 = es2utc(1, out1, ut); 
  if(ret2 < 0){
    printf("es2utc error\n");
    return -1;
  }else{
    printf("es2utc(): ut=%s\n", ut);
  }

  printf("\n");

  return 0;
}
